uniform vec4 sl_outputScale;
uniform sampler2D sl_tex2D;
uniform vec4 sl_noSpin;

void overrideBillboardFragment(in vec4 texColor, in vec4 lightColor, inout vec4 finalColor);
void writeFragmentData(in vec4 finalColor);

varying float altitude;

void main()
{
    vec4 texColor = texture2D(sl_tex2D, gl_TexCoord[0].xy);
    vec4 finalColor = texColor * gl_Color;

    float softness = sl_noSpin.z;
    if (softness > 0.0) {
        float softParticle = clamp(altitude / softness, 0.0, 1.0);
        finalColor = mix(vec4(0.0,0.0,0.0,0.0), finalColor, softParticle);
    }

    overrideBillboardFragment(texColor, gl_Color, finalColor);

    finalColor.xyz *= sl_outputScale.xxx;

    writeFragmentData(finalColor);
}
