uniform vec4 sl_outputScale;
uniform vec4 sl_textureOffset;
uniform sampler2D sl_tex2D;

void overrideCirrusColor(in vec4 texel, in vec4 litColor, inout vec4 finalColor);
void writeFragmentData(in vec4 finalColor);

void main()
{
    vec4 texel = texture2D(sl_tex2D, gl_TexCoord[0].xy + sl_textureOffset.xy);
    vec4 finalColor = texel * gl_Color;
    overrideCirrusColor(texel, gl_Color, finalColor);
    finalColor.xyz *= sl_outputScale.xxx;
    writeFragmentData(finalColor);
}